﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Events declaration
#Event: ValueChanged(Value As Int, UserChanged As Boolean)
#Event: ValueChangedDelayed(Value As Int)

'Class module
Private Sub Class_Globals
Private dr1,dr2 As GradientDrawable
Private slider, caret As ImageView
Private Vpos, H, W,Minv, MaxV, D As Int
Private Hmodule As Object
Private Hbase, cover As Panel
Private BarName As String
Private mybase As Panel
Private TG As Object
Private Delay As Timer
Private Uit As Bitmap
Private Aan As Bitmap
Private achtergrond As ColorDrawable
End Sub

'Initializes the object. No need to use if the object is defined by the designer. 
'Module is the launching module.
Public Sub Initialize(Module As Object, Eventname As String)
Hmodule = Module
BarName = Eventname
End Sub

'If you create the object by code, not by the designer, use this sub after initialization.
Public Sub CodeCreateView( width As Int ,height As Int,MinValue As Int, MaxValue As Int)
H = height
W = width
Minv = MinValue
MaxV = MaxValue
Hbase.Initialize("")
ContinueCreation
End Sub

Private Sub DesignerCreateView(base As Panel, Lbl As Label, Props As Map) 'ignore
mybase = base
mybase.Left = Lbl.Left
mybase.Top = Lbl.top
mybase.Width = Lbl.Width
mybase.Height = Lbl.Height
Hbase.Initialize("")
base.AddView(Hbase,0, 0, Lbl.Width, Lbl.Height)

H = Lbl.Height 
W = Lbl.Width
Dim str() As String = Regex.Split("," , Lbl.Tag)
Minv = str(0)
MaxV = str(1)
ContinueCreation
End Sub

Private Sub ContinueCreation
D = H ' default caret width
slider.Initialize("")
Hbase.AddView(slider,D/2,0+(H/2),W,H/2)
caret.Initialize("")
Hbase.AddView(caret,W/2-D/2,0,D,H)
cover.Initialize("cover")
Hbase.AddView(cover,0,0,W,H)
Delay.Initialize("Delay",100)
Uit.Initialize(File.DirAssets,"apps-preferences-system-power-management-icon.png")
Aan.Initialize(File.DirAssets,"actions-help-hint-icon.png")
									' These are the default colors
setColors(Colors.DarkGray,Colors.Gray,Colors.Blue, Colors.LightGray)
End Sub

'Sets the colors of the bar
Sub setColors(BackGround As Int,basecolor As Int,slidercolor As Int, caretcolor As Int)
Dim clr(3) As Int
clr = Array  As Int(BackGround,basecolor,BackGround)
dr1.Initialize("TOP_BOTTOM",clr)
achtergrond.Initialize(Colors.Transparent,0)
Hbase.BackGround =  achtergrond 'dr1  ' .Initialize(basecolor,BackGround,False)

clr = Array  As Int(BackGround,slidercolor,BackGround) 
dr2.Initialize("TOP_BOTTOM",clr)
slider.BackGround = dr2

caret.Bitmap=Uit
caret.Gravity=Gravity.FILL
End Sub

'Returns the base panel
Public Sub AsView As View 
Return Hbase
End Sub

' Sets the Min and Max values of the bar 
Public Sub setMaxandMin(MinValue As Int, MaxValue As Int)
Minv = MinValue
MaxV = MaxValue
End Sub

'Sets the width of the caret.
'The default is 20dip.
Public Sub setCaretWidth(value As Int)
D = value
caret.Width = D
caret.left = Max(Min(W-D,slider.width-D/2),0)
End Sub

Private Sub setPosition(Value As Int, userchanged As Boolean)
slider.width = Max(Min(W * (Value-Minv)/(MaxV-Minv), W),0)
caret.left = Max(Min(W-D,slider.width-D/2),0)  
Hbase.Invalidate
If SubExists(Hmodule, BarName & "_ValueChanged") Then
  CallSub3(Hmodule,BarName & "_ValueChanged", Value , userchanged )
End If
If Value>0 Then caret.Bitmap=Aan Else caret.Bitmap=Uit
Delay.Enabled=False
Delay.Enabled=True
End Sub

' Sets the value of the bar 
' ValueChanged event will be raised with Userchanged = false
' This function must be performed by code at least once prior to use of the bar.
Public Sub setValue(Value As Int)
Vpos = Value
W = Hbase.Width
setPosition(Vpos,False)
End Sub

' Returns the current value of the bar
Public Sub getValue As Int
Return Vpos
End Sub


Private Sub cover_Touch(Action As Int, X As Float, Y As Float) As Boolean 
Dim k As Int
k = X * (MaxV-Minv) / Hbase.Width + Minv
Vpos = Max(Min(k, MaxV),Minv)
setPosition(Vpos, True)
Return True
End Sub

Public Sub setTag(TGin As Object)
TG=TGin
End Sub

Public Sub getTag As Object
Return TG
End Sub

Public Sub setVisible(VB As Boolean)
Hbase.Visible=VB
End Sub

Public Sub getVisible As Boolean
Return Hbase.Visible
End Sub

Private Sub Delay_Tick
Delay.Enabled=False
If SubExists(Hmodule, BarName & "_ValueChangedDelayed") Then
  CallSub2(Hmodule,BarName & "_ValueChangedDelayed", Vpos)
End If
End Sub