﻿Type=Activity
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim Arduino As IPcomm
	Dim Conn As Boolean

	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private Spinner1 As Spinner
	Private MapSettings As Map

	Private cmdConnect As Button
	Private Panel1 As Panel
	Private ScrollView1 As ScrollView
	
	Private Panel2(16) As Panel
	Private BTN1(16,16) As UnitButton

	Private BTN2(16) As Button
	Private Signal(16) As ImageView
	
	Private clrs As Int
	Private cdpanel As ColorDrawable
	
	Private cdConnect As BitmapDrawable
	Private cdDisconnect As BitmapDrawable
	Private cdWait As BitmapDrawable
	
	Private cdButtongroen As Bitmap
	Private cdButtonrood As Bitmap
	Private cdButtonoranje As Bitmap
	
	Private cdGroepsknop As BitmapDrawable

	Type GroepButtonTags(index As Int,expanded As Boolean)

	Private NrOfGroups As Int
	Private i,j As Int
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Msgbox("create","Activity")
	If FirstTime Then
	  Arduino.Initialize(Me,"Arduino",8900)

	End If
		
	clrs=Colors.ARGB(100,0,0,0)
	cdpanel.Initialize(clrs,10)
	MapSettings.Initialize

	
	cdConnect.Initialize(LoadBitmap(File.DirAssets,"Actions-network-connect-icon.png"))
	cdDisconnect.Initialize(LoadBitmap(File.DirAssets,"Actions-network-disconnect-icon.png"))
	cdWait.Initialize(LoadBitmap(File.DirAssets,"Actions-view-history-icon.png"))
	cdGroepsknop.Initialize(LoadBitmap(File.DirAssets,"button_wood.png"))
	cdButtonrood.Initialize(File.DirAssets,"001.png")
	cdButtongroen.Initialize(File.DirAssets,"030.png")
	cdButtonoranje.Initialize(File.DirAssets,"015.png")
		
	Dim y1 As Int
	
	Dim breedte As Int=90%x
	
	Activity.LoadLayout("Main")
		
	Panel1.Width=90%x
	Panel1.Height=10%y
	Panel1.Top=1%y
	Panel1.Left=5%x
		
	y1=Panel1.Height
	
	ScrollView1.Height=100%y-y1
	ScrollView1.Width =100%x
	ScrollView1.Top=11%y
	ScrollView1.Left=0
	
	Spinner1.Height=0.9*y1
	Spinner1.Width=breedte-(0.9*y1)
	Spinner1.Left=0
	Spinner1.Top=0.05*y1
	Spinner1.TextSize=20
	
	cmdConnect.Height=0.9*y1
	cmdConnect.Width=cmdConnect.Height
	cmdConnect.Left=Spinner1.Width
	cmdConnect.Top=0.05*y1
	cmdConnect.Background=cdDisconnect
	
	
	ScrollView1.Panel.Height=182%y
	For j=1 To 15
		Panel2(j).Initialize("Panel2")
		ScrollView1.Panel.AddView(Panel2(j),5%x,(j-1)*(12%y)+1%y,breedte,11%y)
		Panel2(j).Background=cdpanel
		
		BTN2(j).Initialize("Groepsknop")
		Panel2(j).AddView(BTN2(j),0.05*Panel2(j).Width,1%y,0.9*Panel2(j).Width,9%y)
		BTN2(j).TextSize=20 
		BTN2(j).Text="Group "&j
		BTN2(j).Background=cdGroepsknop
		
		Signal(j).Initialize("Signal")
		Panel2(j).AddView(Signal(j),0.075*Panel2(j).Width,BTN2(j).top + 0.25*BTN2(j).height,0.5*BTN2(j).height,0.5*BTN2(j).height)
		Signal(j).Gravity=Gravity.FILL
		Signal(j).Bitmap=cdButtongroen

Dim t As GroepButtonTags
		t.index=j
		BTN2(j).Tag=t

		For i=1 To 15
	  		BTN1(j,i).Initialize(Me,"BTN1",0.1*Panel2(j).Width,(i)*(10%y)+1%y,0.85*Panel2(j).Width,9%y)
			Panel2(j).AddView(BTN1(j,i).AsView,0.1*Panel2(j).Width,(i)*(10%y)+1%y,0.85*Panel2(j).Width,9%y)  
			
			BTN1(j,i).index=(j*16)+i
			BTN1(j,i).Group=j
			BTN1(j,i).Unit=i
			
		Next
		
	Next
End Sub

Sub Activity_Resume
	Spinner1.Clear
	If File.Exists(File.DirInternal,"Settings.txt") Then
		MapSettings=File.ReadMap(File.DirInternal,"Settings.txt")
		If MapSettings.Get("Systems")>0 Then
			For i=1 To MapSettings.Get("Systems")
		  		Spinner1.Add(MapSettings.Get("Name"&i))
			Next
			SetButtons
			If Conn Then 'Or (MapSettings.Get("Systems")="1") Then
				Conn=True
				cmdConnect.Background=cdWait
				Arduino.Connect(MapSettings.get("IP"&(Spinner1.SelectedIndex+1)),MapSettings.get("Port"&(Spinner1.SelectedIndex+1)),MapSettings.get("Pass"&(Spinner1.SelectedIndex+1)))
			End If
		Else
			StartActivity(Settings)
		End If
	Else
		StartActivity(Settings)
	End If
	
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If Arduino.isConnected Then
		Arduino.Disconnect
	End If
	
	If UserClosed Then Conn=False
End Sub

Sub Groepsknop_Down
Dim Knop As Button
Knop=Sender
Knop.TextColor=Colors.Cyan
End Sub

Sub Groepsknop_Up
Dim Knop As Button
Knop=Sender
Knop.TextColor=Colors.White
End Sub

Sub Groepsknop_click
Dim Knop As Button
Knop=Sender
Dim t As GroepButtonTags
		t=Knop.tag
If Panel2(t.index).Height=11%y Then
	Panel2(t.index).Height=(Panel2(t.index).tag*10%y) + 11%y
	If t.index<15 Then
		For i=t.index+1 To NrOfGroups
			Panel2(i).Top=Panel2(i).Top+(Panel2(t.index).tag*10%y)
		Next
	End If
	ScrollView1.Panel.Height=Panel2(NrOfGroups).top+Panel2(NrOfGroups).Height
Else
	Panel2(t.index).Height=11%y
	If t.index<15 Then
		For i=t.index+1 To NrOfGroups
			Panel2(i).Top=Panel2(i).Top-(Panel2(t.index).tag*10%y)
		Next
	End If
End If
	ScrollView1.Panel.Height=Panel2(NrOfGroups).top+Panel2(NrOfGroups).Height + 2%y
End Sub

Sub groepsknop_longclick
	Dim Knop As Button
	Knop=Sender
	Dim t As GroepButtonTags
	t=Knop.Tag
	If Arduino.isConnected Then
		If Signal(t.index).Bitmap=cdButtongroen Then 
			Arduino.Direct(3,16*t.index,0)
		Else
			Arduino.Direct(3,16*t.index,1)
		End If
	End If
End Sub

Sub Arduino_ConnectionEstablished (Version As String, Name As String)
    cmdConnect.Background=cdConnect
End Sub

Sub Arduino_Disconnected (Reason As Int)
	cmdConnect.Background=cdDisconnect
End Sub

Sub Arduino_ConnectionTimeOut
	Msgbox("Controleer Adres, Poort en Wachtwoord","Verbinden lukt niet!")
	Conn=False
  	StartActivity(Settings)
End Sub

Sub cmdConnect_click
	Conn=Not(Conn)
	cmdConnect.Background=cdWait
	If Conn Then
		Arduino.Connect(MapSettings.get("IP"&(Spinner1.SelectedIndex+1)),MapSettings.get("Port"&(Spinner1.SelectedIndex+1)),MapSettings.get("Pass"&(Spinner1.SelectedIndex+1)))
	Else
		Arduino.Disconnect
	End If
End Sub

Sub cmdConnect_Longclick
	Conn=False
  	StartActivity(Settings)
End Sub

Sub Arduino_ReceivedStatusGroups (Groups() As Int)
 Dim AllOn As Boolean
 Dim AllOff As Boolean
 For i = 1 To NrOfGroups
 	AllOn=True
	AllOff=True
	Log(Panel2(i).Tag)
    For j = 1 To Panel2(i).Tag
        If Bit.And(Groups(i),Bit.ShiftLeft(1,(j - 1))) = Bit.ShiftLeft(1,(j - 1)) Then
            'BTN1(i,j).Value=16
			AllOff=False
        Else
            'BTN1(i,j).Value=0
			AllOn=False
        End If
    Next
	
	If Groups(i)<>0 And (AllOff=False) Then 
	 	If (Groups(i)=255) Or (AllOn=True) Then
			Signal(i).Bitmap=cdButtongroen
		Else
			Signal(i).Bitmap=cdButtonoranje
		End If
	Else 
		Signal(i).Bitmap=cdButtonrood
	End If
  Next
  End Sub
  
Sub Spinner1_ItemClick (Position As Int, Value As Object)
	SetButtons
End Sub

Sub SetButtons
NrOfGroups=15
For i=1 To 15
  BTN2(i).Text=MapSettings.Get("S"&(Spinner1.SelectedIndex+1)&"G"&0&"U"&i)
  Log(BTN2(i).Text=MapSettings.Get("S"&(Spinner1.SelectedIndex+1)&"G"&0&"U"&i))
  If BTN2(i).Text.Trim="" Then
    NrOfGroups=i-1
	Exit
 End If
Next
For i=1 To NrOfGroups
  For j=1 To 15
    BTN1(i,j).Text=MapSettings.Get("S"&(Spinner1.SelectedIndex+1)&"G"&i&"U"&j)
	Log(MapSettings.Get("S"&(Spinner1.SelectedIndex+1)&"G"&i&"U"&j))
	If BTN1(i,j).Text.Trim="" Then
      Panel2(i).Tag=j-1
	  Exit
    End If
	
	BTN1(i,j).IsDimmer=(Bit.And(MapSettings.Get("S"&(Spinner1.SelectedIndex+1)&"G"&i&"U"&j&"T"),64)=64)
	Next
Next
If NrOfGroups<15 Then
  For i=1 To NrOfGroups
  	Panel2(i).Visible=True
  Next
  For i=NrOfGroups+1 To 15
  	Panel2(i).Visible=False
  Next
End If
End Sub

Sub BTN1_ValueChangedDelayed (Value As Int)
	Dim Knop As UnitButton
	Knop=Sender
	If Arduino.isConnected Then
		If Value=0 Then
			Arduino.Direct(1,Knop.Index,0)
		Else
			If Knop.IsDimmer Then
				Arduino.Direct(2,Knop.Index,Value-1)
			Else
				Arduino.Direct(1,Knop.Index,1)
			End If
		End If
	End If
End Sub

