﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

'Class module
'Events declaration
#Event: ConnectionEstablished(Version as String, Name As String)

Sub Class_Globals
   Dim Socket1 As UDPSocket
   Dim outPacket As UDPPacket
   Dim connectedaddress As Byte
   Dim Polltimer As Timer
   Dim Polltimeout As Byte
   Dim ConnectionTimer As Timer
   Public State As Byte
   Public Disconnected=0 As Byte
   Public WaitForConnection=1 As Byte
   Public Connected=2 As Byte
   
   Dim DisconnectRequest As Boolean
   Dim isConnected As Boolean
   Dim Host As String
   Dim Port As Long
   Dim StringSize As Int = 16
   'Dim conv As Byteconverter
   'Dim Downloadadres As Int
   'Dim Downloaddata() As Byte
   Private module As Object
   Private eventName As String

End Sub

'Initializes the object. You can add parameters to this method if needed.
Sub Initialize (ModulePar As Object, EventNamePar As String,outPort As Int)
   module = ModulePar
   eventName = EventNamePar

  Socket1.Initialize("Socket1",outPort,512)
  Polltimer.Initialize("Polltimer",1500)
  Polltimer.Enabled=False
  ConnectionTimer.Initialize("ConnectionTimer",4000)
  ConnectionTimer.Enabled=False
End Sub

Private Sub getCheckSum(ByteArray() As Byte) As Byte
 Dim Value As Byte
 Dim i As Int
 Value = 0
 For i = 0 To ByteArray.Length-1
   Value = Bit.Xor(Value , ByteArray(i))
 Next
Return Value
End Sub

Private Sub Check(ByteArray() As Byte) As Boolean
  Dim Checksum As Byte
  Checksum = ByteArray(1)
  ByteArray(1) = 0
  
  If getCheckSum(ByteArray) = Checksum Then 
  Return True
  Else
  Return False
  End If
End Sub

Public Sub GetStatus()
  Dim Data(5) As Byte
  Data(0) = 97
  Data(1) = 0
  Data(2) = 8
  Data(3) = connectedaddress
  Data(4) = 122
  
  Data(1) = getCheckSum(Data)
  
  	outPacket.Initialize(Data, Host, Port)
	Socket1.Send(outPacket)

End Sub
  
Public Sub Updone()
Dim Data(5) As Byte
    Data(0) = 97
    Data(1) = 0
    Data(2) = 6
    Data(3) = connectedaddress
    Data(4) = 122
    
    Data(1) = getCheckSum(Data)
    
    outPacket.Initialize(Data, Host, Port)
	Socket1.Send(outPacket)

End Sub

Public Sub Upload(adres As Int, Up() As Byte)

  Dim Data(StringSize + 7) As Byte
  For i = 0 To Up.Length-1
    Data(i + 6) = Up(i)
  Next
  
  Data(0) = 97
  Data(1) = 0
  Data(2) = 5
  Data(3) = connectedaddress
  Data(4) = Bit.ShiftRight(adres - 1,8)
  Data(5) = Bit.And(adres - 1, 255)
  Data(Data.Length-1) = 122
  
  Data(1) = getCheckSum(Data)
  	outPacket.Initialize(Data, Host, Port)
	Socket1.Send(outPacket)

  
End Sub

Public Sub Download(address As Int, Size As Byte)'As Byte()

  Dim Data(8) As Byte
  Data(0) = 97
  Data(1) = 0
  Data(2) = 7
  Data(3) = connectedaddress
  Data(4) = Bit.ShiftRight(address,8)
  Data(5) = Bit.And(address, 255)
  Data(6) = Size
  Data(7) = 122
  
  Data(1) = getCheckSum(Data)
  
  outPacket.Initialize(Data, Host, Port)
  Socket1.Send(outPacket)

End Sub

Public Sub Direct(Command As Byte, Unit As Byte, Value As Byte)
      Dim Data(8) As Byte
      Data(0) = 97
      Data(1) = 0
      Data(2) = 3
      Data(3) = connectedaddress
      Data(4) = Command
      Data(5) = Unit
      Data(6) = Value
      Data(7) = 122
      Data(1) = getCheckSum(Data)
      
      	outPacket.Initialize(Data, Host, Port)
	Socket1.Send(outPacket)


End Sub

Public Sub Settime(DayOfWeek As Byte, Dag As Byte, Maand As Byte, Jaar As Byte, Uur As Byte, Minuut As Byte, Seconde As Byte)
Dim Data(12) As Byte
  Data(0) = 97
  Data(1) = 0
  Data(2) = 4
  Data(3) = connectedaddress
  Data(4) = DayOfWeek
  Data(5) = Dag
  Data(6) = Maand
  Data(7) = Jaar
  Data(8) = Uur
  Data(9) = Minuut
  Data(10) = Seconde
  Data(11) = 122
  Data(1) = getCheckSum(Data)
  
  	outPacket.Initialize(Data, Host, Port)
	Socket1.Send(outPacket)

End Sub

Public Sub Disconnect()
  DisconnectRequest = True
  
  Dim Data(5) As Byte
  Data(0) = 97
  Data(1) = 0
  Data(2) = 2
  Data(3) = connectedaddress
  Data(4) = 122
  
  Data(1) = getCheckSum(Data)
  
  outPacket.Initialize(Data, Host, Port)
  Socket1.Send(outPacket)
  isConnected = False
  Polltimer.Enabled = False


End Sub

Public Sub Connect(inHost As String, inPort As Int, PassKey As String)
  
  Host=inHost
  Port=inPort

  Dim Data(21) As Byte
  Data(0) = 97
  Data(1) = 0
  Data(2) = 1
  Data(3) = connectedaddress
  
  Dim i As Int, Pass() As Byte
  Pass = PassKey.GetBytes("UTF8")
  For i = 0 To 15
    If i <= Pass.Length-1 Then
    Data(4 + i) = Pass(i)
    Else
    Data(4 + i) = 0
    End If
  Next
  Data(20) = 122
  
  Data(1) = getCheckSum(Data)
  
  	outPacket.Initialize(Data, Host, Port)
	Socket1.Send(outPacket)
ConnectionTimer.Enabled=True
End Sub

Public Sub Discover()
Dim Data(3) As Byte
  Data(0) = 123
  Data(1) = 95
  Data(2) = 125
  outPacket.Initialize(Data,"255.255.255.255", 15234)
  Socket1.Send(outPacket)

End Sub


Private Sub PollTimer_Tick()
Polltimeout=Polltimeout+1
  If Polltimeout > 7 Then
    isConnected = False
    Polltimer.Enabled = False
    CallSub2(module,eventName&"_Disconnected",0)
  Else
  ' Stuur Pollbericht
  Log("send Poll")
    Dim Data(5) As Byte
    Data(0) = 97
    Data(1) = 0
    Data(2) = 0
    Data(3) = connectedaddress
    Data(4) = 122
  
    Data(1) = getCheckSum(Data)
  
    outPacket.Initialize(Data, Host, Port)
	Socket1.Send(outPacket)

  End If
  
End Sub

Private Sub Socket1_PacketArrived (Packet As UDPPacket)
  
  
  Dim adres As Int
  Dim Name As String
  Dim Version As String
	Dim inData(Packet.Length) As Byte
  	inData=Packet.Data
  
    Log("Data ontvangen, lengte:"&Packet.Length)
	
  If Check(inData) And (inData(0) = 97) And (inData(Packet.Length - 1)) = 122 Then
  
  Log("data goedgekeurd, antwoord: "&inData(2))
  Select Case inData(2)
Case 0
  Polltimeout=0
Case 1
  Log("Connection Established")
  Version = inData(4) & "." & inData(5) & " " & inData(6) & "-" & inData(7) & "-20" & inData(8)
  Name = BytesToString(inData,9,16,"UTF-8")
  Log(Name)
  connectedaddress = inData(3)
  isConnected = True
  Polltimeout = 0
  Polltimer.Enabled = True
  ConnectionTimer.Enabled=False
  CallSub3(module, eventName & "_ConnectionEstablished",Version, Name)
  
Case 2
  isConnected = False
  Polltimer.Enabled = False
  If DisconnectRequest = True Then
    DisconnectRequest = False
    CallSub2(module,eventName&"_Disconnected",1)

Else
    CallSub2(module,eventName&"_Disconnected",2)
  End If
'Case 4
'  Dim Datum As String
'  Dim Tijd As String
'  If inData(3) > 0 AND inData(3) < 8 Then
'    Datum = WeekdayName(inData(3), True, vbSunday) + " " + CStr(inData(4)) + "-" + CStr(inData(5)) + "-" + Format$(CStr(inData(6)), "\2\000")
'    Tijd = inData(7) & ":" + Format$(CStr(inData(8)), "00")
'  Else
'    Datum = "Ongeldig"
'    Tijd = "Ongeldig"
'  End If
'  CallSub3(module,eventName&"_ReceivedTime",Datum,Tijd)
Case 5
  
  adres = Bit.Or(inData(3) * 256,  Bit.And(inData(4),255)) 
  CallSub2(module,eventName&"_Upload",adres)
Case 7
  adres = Bit.Or(inData(3) * 256,  Bit.And(inData(4),255)) 
  
  Dim Data(Packet.Length - 6) As Byte
  
  For i = 0 To Data.length - 1
    Data(i) = inData(i + 5)
  Next

  CallSub3(module,eventName&"_Download",adres, Data)
'Case 8
'  Dim Vlaggen As Long
'  Vlaggen = (inData(3) * 256&) OR inData(4)
'  
'  RaiseEvent ReceivedStatusFlags(Vlaggen)
Case 9
  Dim Groepen(16) As Int
  For i = 1 To 15
    Groepen(i) = Bit.Or(Bit.And(inData(i * 2 + 1) * 256,255), Bit.And(inData(i * 2 + 2),255))
  Next
  CallSub2(module,eventName&"_ReceivedStatusGroups",Groepen)
'Case 10
'     Dim actief(5) As Long
'   For i = 0 To 5
'     actief(i) = (inData(i * 2 + 3) * 256&) OR inData(i * 2 + 4)
'   Next i
'  RaiseEvent ReceivedStatusTransmitters(actief)
'Case 11
'  Dim zenderadres As Currency
'  zenderadres = (&H1000000 * inData(3)) + (&H10000 * inData(4)) + (&H100& * inData(5)) + inData(6)
 ' 
'  RaiseEvent ReceivedTransmitter(zenderadres, inData(7))
'Case 12
'  
'  Version = CStr(inData(25)) + "." + CStr(inData(26)) + " " + CStr(inData(27)) + "-" + CStr(inData(28)) + "-20" + CStr(inData(29))
'  For i = 0 To 15
'    Name = Name + Chr$(inData(3 + i))
'  Next
'  IPAddress = CStr(inData(19)) + "." + CStr(inData(20)) + "." + CStr(inData(21)) + "." + CStr(inData(22))
'  Port = CStr((256 * inData(23)) + inData(24))
'  
'  RaiseEvent Found(Name, Version, IPAddress, Port)
'Case 13
'  Dim Inputs As Int
'  Inputs = (inData(3) * 256&) OR inData(4)
'  
'  RaiseEvent ReceivedStatusWiredInputs(Inputs)
'Case Else
'  RaiseEvent ReceivedOther(inData)
End Select
End If
End Sub
Private Sub ConnectionTimer_Tick
ConnectionTimer.Enabled=False
CallSub(module,eventName&"_ConnectionTimeOut")
End Sub